<template>
    <div>
        <div
            class="w-full flex flex-col items-center"
            v-for="(muzzle, index) in muzzles"
            :key="index"
        >
            <item
                category="muzzle"
                :existingNumber="getExistingNumber(muzzle.name)"
                :existingTotalCapacity="existingTotalCapacity"
                :existingTotalWeight="existingTotalWeight"
                :steps="1"
                :index="index"
                :item="muzzle"
                @output="handleOutput"
            ></item>
        </div>
    </div>
</template>

<script lang='ts'>
import Vue from 'vue'
import Component from 'vue-class-component'
import { Prop } from 'vue-property-decorator'
import { State } from 'vuex-class'
import { IURLState } from '../categories/store/types'
import Item from '../components/Item.vue'

@Component({
    components: {
        Item,
    },
})
export default class App extends Vue {
    @Prop() existing: {
        muzzle: { name: string; number: number }[]
    }
    @Prop({ default: 70 }) existingTotalCapacity: number
    @Prop({ default: 0 }) existingTotalWeight: number

    @State('URLS') URLS_State: IURLState

    get muzzles() {
        return this.URLS_State.urls.muzzle
    }

    get existingMuzzles() {
        if (this.existing === null || this.existing.muzzle === undefined)
            return []
        return this.existing.muzzle
    }

    handleOutput(output: any) {
        this.$emit('output', output)
    }

    getExistingNumber(name: string): number | null {
        if (this.existingMuzzles.length === 0) return null
        const [selection] = this.existingMuzzles.filter(
            muzzle => muzzle.name === name
        )
        if (selection === undefined) return null
        return selection.number
    }
}
</script>